// This code is distributed under the terms of the GNU General Public License.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.IO;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace JSON_Formatter
{
    static class Program
    {
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            //Application.Run(new Form1());
            string clipboard_text = Clipboard.GetText().Trim();
            if (clipboard_text.Length == 0)
            {
                Application.Exit();
                return;
            }
            try
            {
                string json = Prettify_JSON(clipboard_text);
                Clipboard.Clear();
                Clipboard.SetText(json);
            }
            catch (Exception e)
            {
                MessageBox.Show("An error occurred while formatting the JSON." + Environment.NewLine + Environment.NewLine + e.Message, "JSON Formatter");
            }
        }

        public static string Prettify_JSON(string raw_json)
        {
            using (var stringReader = new StringReader(raw_json))
            using (var stringWriter = new StringWriter())
            {
                var jsonReader = new JsonTextReader(stringReader);
                var jsonWriter = new JsonTextWriter(stringWriter) { Formatting = Formatting.Indented };
                jsonWriter.WriteToken(jsonReader);
                return stringWriter.ToString();
            }
        }
    }
}
